package com.ideabus.sdk_test;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;

import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;
import androidx.core.app.ActivityCompat;
import androidx.core.app.ActivityOptionsCompat;
import androidx.core.content.ContextCompat;
import androidx.work.ExistingPeriodicWorkPolicy;
import androidx.work.PeriodicWorkRequest;
import androidx.work.WorkManager;

import com.ideabus.model.XlogUtils;

import java.util.Arrays;
import java.util.Map;
import java.util.concurrent.TimeUnit;

public class ChoseActivity extends AppCompatActivity implements View.OnClickListener{
    private static final String TAG = ChoseActivity.class.getSimpleName();

    private Button btn_bpm;
    private Button btn_weight;
    private Button btn_bt;
    private Button btn_wbp;
    private Button btn_wbo3;
    private Button btn_wbo;
    private Button btn_sp;
    private Button btn_spo2;
    private Toolbar toolbar;

    private String[] LocationPermission = { Manifest.permission.ACCESS_COARSE_LOCATION,
                                            Manifest.permission.ACCESS_FINE_LOCATION};
    private static final int Location_Request = 1;
    //private static final String sdkVersion = com.ideabus.model.protocol.Global.sdkVersion BuildConfig.VERSION

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_chose);
        Log.w(TAG, "onCreate() ...");
        checkLocationPermission();
        //Log.w(TAG, "onCreate() end");
    }

    private void checkLocationPermission() {
        Log.w(TAG, "checkLocationPermission() ...");
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.S) {
            int scanPermission = ContextCompat.checkSelfPermission(this,
                    Manifest.permission.BLUETOOTH_SCAN);
            Log.w(TAG,"Android 12 scanPermission: " + scanPermission);
            if (scanPermission != PackageManager.PERMISSION_GRANTED) {
                Boolean state = isScanPermission();
                Log.w(TAG, "state: " + state);
                if (!state)
                {
                    finish();
                }
            }
            else
                initParam();
        }
        else
        {
            Log.w(TAG,"Android 11 ~ 8 ");
            if ((ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) ||
                (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED)) {
//            CoordinatorLayout coordinatorLayout = (CoordinatorLayout) findViewById(R.id.coordinatorLayout);
                Log.w(TAG," 22222 ... ");
                if (ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.ACCESS_COARSE_LOCATION) ||
                        ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.ACCESS_FINE_LOCATION)) {

                    Log.w(TAG," AlertDialog.Builder... ");
                    final AlertDialog.Builder builder = new AlertDialog.Builder(this);
                    builder.setMessage("需要給予權限，否則不能連接設備");
                    builder.setPositiveButton("是", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            ActivityCompat.requestPermissions(ChoseActivity.this, LocationPermission, Location_Request);
                        }
                    });
                    builder.setNeutralButton("否", null);

/*
                Snackbar.make(coordinatorLayout, "需要給予權限，否則不能連接設備", Snackbar.LENGTH_INDEFINITE)
                        .setAction(getString("確定"), v -> {
                            ActivityCompat.requestPermissions(ChoseActivity.this, LocationPermission, Location_Request);
                        }).show();
*/
                    //locationLaunch.launch(LocationPermission);
                } else {
                    Log.w(TAG," None things ... ");
                    ActivityCompat.requestPermissions(ChoseActivity.this, LocationPermission, Location_Request);
                }

            } else {
                initParam();
            }
        }
    }

    private final ActivityResultLauncher locationLaunch = registerForActivityResult(
            new ActivityResultContracts.RequestPermission(),
            new ActivityResultCallback<Boolean>() {
                @Override
                public void onActivityResult(Boolean result) {
                    Log.w(TAG," onActivityResult(), result: " + result);
                    final AlertDialog.Builder builder = new AlertDialog.Builder(getBaseContext());
                    builder.setMessage("需要給予權限，否則不能連接設備");
                    builder.setPositiveButton("是", new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            locationLaunch.launch(ChoseActivity.this, ActivityOptionsCompat.makeTaskLaunchBehind());
                            ActivityCompat.requestPermissions(ChoseActivity.this,
                                    LocationPermission, Location_Request);
                        }
                    });
                    builder.setNeutralButton("否", null);

                }
            });

    @RequiresApi(api = Build.VERSION_CODES.S)
    private boolean isScanPermission()
    {
        Log.w(TAG, "isScanPermission() ...");

        if (!ActivityCompat.shouldShowRequestPermissionRationale(this,
                Manifest.permission.BLUETOOTH_SCAN))
        {

            ActivityCompat.requestPermissions(this,
                    new String[] {  Manifest.permission.BLUETOOTH_SCAN,
                            Manifest.permission.BLUETOOTH_CONNECT,
                            Manifest.permission.BLUETOOTH_ADVERTISE}, 1);

            /*
            requestLauncher.launch(new String[] {  Manifest.permission.BLUETOOTH_SCAN,
                    Manifest.permission.BLUETOOTH_CONNECT,
                    Manifest.permission.BLUETOOTH_ADVERTISE});
            return false;

             */
        }

        return true;
    }

    private ActivityResultLauncher<String[]> requestLauncher = registerForActivityResult(
            new ActivityResultContracts.RequestMultiplePermissions(),
            new ActivityResultCallback<Map<String, Boolean>>() {
                //@RequiresApi(api = Build.VERSION_CODES.S)
                @Override
                public void onActivityResult(Map<String, Boolean> result) {
                    Log.w(TAG,"Map onActivityResult(), result: " + result);
                    //List<String> mapList = new ArrayList<String>(result.keySet());
                    for (Boolean permission: result.values()) {
                        if (!permission)
                        {
                            Log.e(TAG, "" + result.keySet());
                            //isScanPermission();
                            return;
                        }
                    }

                    initParam();
                }
            });



    private void initParam() {
        Log.w(TAG," initParam(), ");
        toolbar = (Toolbar) findViewById(R.id.tool_bar);
        btn_bpm = (Button) findViewById(R.id.btn_bpm);
        btn_weight = (Button) findViewById(R.id.btn_eBody);
        btn_bt = (Button) findViewById(R.id.btn_bt);
        btn_spo2 = (Button) findViewById(R.id.btn_spo2);
        btn_wbp = (Button) findViewById(R.id.btn_wbp);
        btn_wbo3 = (Button) findViewById(R.id.btn_wbo3);
        btn_wbo = (Button) findViewById(R.id.btn_wbo);
        btn_sp = (Button) findViewById(R.id.btn_sp);

        btn_bpm.setOnClickListener(this);
        btn_weight.setOnClickListener(this);
        btn_bt.setOnClickListener(this);
        btn_spo2.setOnClickListener(this);
        btn_wbp.setOnClickListener(this);
        btn_wbo3.setOnClickListener(this);
        btn_wbo.setOnClickListener(this);
        btn_sp.setOnClickListener(this);

        toolbar.setSubtitle("V" + BuildConfig.VERSION_NAME + "(" + BuildConfig.VERSION_CODE + ") ");

        setSupportActionBar(toolbar);

        XlogUtils.initXlog(this, true);
        PeriodicWorkRequest workRequest = new PeriodicWorkRequest.Builder(Mywork.class, 15, TimeUnit.MINUTES).build();
        WorkManager.getInstance(this).enqueueUniquePeriodicWork("1qaz2wsx3edc", ExistingPeriodicWorkPolicy.REPLACE,workRequest);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        Log.w(TAG," onRequestPermissionsResult(), requestCode: " + requestCode +
                        ", grantResults: " + Arrays.toString(grantResults) +
                ", permissions: " + Arrays.toString(permissions));
        
        //if (requestCode == 100) {
        //    Log.e(TAG, " 100");
        //    for (int i = 0; i <permissions.length; i++) {
        //        //Log.w(TAG, "grantResults[" + i + "]: " + grantResults[i] + ", " + permissions[i]);
        //
        //        if (grantResults[i] != PackageManager.PERMISSION_GRANTED) {
        //            //Log.w(TAG, "[" + i + "]: " + permissions[i]);
        //            Toast.makeText(getBaseContext(), " permission NOT granted !!", Toast.LENGTH_LONG).show();
        //            try {
        //                Thread.sleep(10);
        //            } catch (InterruptedException e) {
        //                e.printStackTrace();
        //            }
        //            return;
        //        }
        //
        //        Log.e(TAG, i + ": 101");
        //
        //        /*
        //        if (grantResults[1] != PackageManager.PERMISSION_GRANTED) {
        //            Toast.makeText(this, "External storage write permission NOT granted !!", Toast.LENGTH_SHORT).show();
        //        }
        //
        //        Log.e(TAG, " 102");
        //        if (grantResults[2] != PackageManager.PERMISSION_GRANTED) {
        //            //Toast.makeText(getApplicationContext(), "Camera permission NOT granted !!", Toast.LENGTH_SHORT).show();
        //            ActivityCompat.requestPermissions(ChoseActivity.this, new String[]{Manifest.permission.CAMERA}, 100);
        //            try {
        //                Thread.sleep(10);
        //            } catch (InterruptedException e) {
        //                e.printStackTrace();
        //            }
        //            return;
        //        }
        //        Log.w(TAG, "permissions: " + Arrays.toString(permissions));
        //
        //         */
        //    }
        //}

        if ((requestCode == Location_Request) &&
            (grantResults[0] == PackageManager.PERMISSION_GRANTED) &&
            (grantResults[1] == PackageManager.PERMISSION_GRANTED)) {
            initParam();
        } else {
            finish();
        }

    }


    @SuppressLint("NonConstantResourceId")
    @Override
    public void onClick(View v) {
        Log.w(TAG," onClick(), v: " + v.getId());
        switch (v.getId()) {
            case R.id.btn_bpm:
                if (checkSDKID(Global.sdkid_BPM))
                    startActivity(new Intent(this, BPMTestActivity.class));
                break;
            case R.id.btn_eBody:
                if (checkSDKID(Global.sdkid_WEI))
                    startActivity(new Intent(this, WeightTestActivity.class));
                break;
            case R.id.btn_bt:
                if (checkSDKID(Global.sdkid_BT))
                    startActivity(new Intent(this, BtTestActivity.class));
                break;
            case R.id.btn_spo2:
                if (checkSDKID(Global.sdkid_SPO2))
                    startActivity(new Intent(this, SPO2TestActivity.class));
                break;
            case R.id.btn_wbp:
                if (checkSDKID(Global.sdkid_WBP))
                    startActivity(new Intent(this, WBPTestActivity.class));
                break;
            case R.id.btn_wbo3:
                if (checkSDKID(Global.sdkid_WBP))
                    startActivity(new Intent(this, WBO3TestActivity.class));
                break;
            case R.id.btn_wbo:
                if (checkSDKID(Global.sdkid_WBP))
                    startActivity(new Intent(this, WBOTestActivity.class));
                break;
            case R.id.btn_sp:
                String SDK_Version = "V" +BuildConfig.VERSION_NAME + "(" + BuildConfig.VERSION_CODE + ")";
                Uri logUri = null;
                if (Global.bpmProtocol != null) {
                    logUri = Global.bpmProtocol.getLogZip(BuildConfig.APPLICATION_ID);
                } else if (Global.thermoProtocol != null) {
                    logUri = Global.thermoProtocol.getLogZip(BuildConfig.APPLICATION_ID);
                } else if (Global.eBodyProtocol != null) {
                    logUri =Global.eBodyProtocol.getLogZip(BuildConfig.APPLICATION_ID);
                } else if (Global.wbpProtocol != null) {
                    logUri = Global.wbpProtocol.getLogZip(BuildConfig.APPLICATION_ID);
                } else if (Global.wboProtocol != null) {
                    logUri = Global.wboProtocol.getLogZip(BuildConfig.APPLICATION_ID);
                    SDK_Version = Global.wboProtocol.getSDKVersion();
                } else if (Global.wbo3Protocol != null) {
                    logUri = Global.wbo3Protocol.getLogZip(BuildConfig.APPLICATION_ID);
                }
                if (logUri != null) {
                    Log.d("logUri", String.valueOf(logUri));
                    //send Support Mail to Microlife
                    /*
                    if (Global.bpmProtocol != null) {
                        Global.bpmProtocol.sendSupportMail("SDK DEMO",SDK_Version,BuildConfig.APPLICATION_ID);
                    } else if (Global.thermoProtocol != null) {
                        Global.thermoProtocol.sendSupportMail("SDK DEMO",SDK_Version,BuildConfig.APPLICATION_ID);
                    } else if (Global.eBodyProtocol != null) {
                        Global.eBodyProtocol.sendSupportMail("SDK DEMO",SDK_Version,BuildConfig.APPLICATION_ID);
                    } else if (Global.wbpProtocol != null) {
                        Global.wbpProtocol.sendSupportMail("SDK DEMO",SDK_Version,BuildConfig.APPLICATION_ID);
                    } else if (Global.wboProtocol != null) {
                        Global.wboProtocol.sendSupportMail("SDK DEMO",SDK_Version,BuildConfig.APPLICATION_ID);
                    } else if (Global.wbo3Protocol != null) {
                        Global.wbo3Protocol.sendSupportMail("SDK DEMO",SDK_Version,BuildConfig.APPLICATION_ID);
                    }
                     */
                }
                break;
        }
    }


    private boolean checkSDKID(final String id)
    {
        if (id.equalsIgnoreCase(""))
        {
            AlertDialog.Builder builder = new AlertDialog.Builder(this);
            builder.setTitle(" Error !! ");
            builder.setMessage(" NO SDK ID is in \"Global.java\" file.");
            builder.create().show();
            builder.setCancelable(false);
            builder.setNegativeButton("OK",
                    (dialog, which) -> dialog.dismiss());
            return false;
        }
        else
            return true;
    }
}
